package cz.cvut.fit.bilybran.wholacksthevax.hasher;


import cz.cvut.fit.bilybran.wholacksthevax.exceptionhandling.exception.hasher.IncorrectHashingAlgorithm;
import org.junit.jupiter.api.DisplayName;
import org.junit.jupiter.api.Test;

import static org.assertj.core.api.Assertions.assertThat;
import static org.assertj.core.api.Assertions.assertThatThrownBy;

public class StringHasherTest {

    @Test
    public void input_hashingWithImplicitAlgorithm_correctSHA256Hash() {
        String input = "th1sIsSuperStr0ngPa$$w0rd";
        //generated by https://passwordsgenerator.net/sha256-hash-generator/
        String expectedHash = "fc3fba6d04183664dc21986555188cdf305ab7176454410d5aac19dc84b8d9d6";

        assertThat(StringHasher.generateHash(input)).isEqualTo(expectedHash);
    }

    @Test
    @DisplayName("Testing if StringHasher always returns hash of correct length")
    public void input_hashingWithImplicitAlgorithm_correctHashLength() {
        String input = "Be$tPass2ordInDaWorld";
        assertThat(StringHasher.generateHash(input)).hasSize(64);

        input = "1";
        assertThat(StringHasher.generateHash(input)).hasSize(64);

        input= "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Cras et metus dui. Quisque sodales in dolor ac convallis. " +
                "Aenean consequat tortor et eros tincidunt facilisis. Vestibulum vestibulum aliquet purus, a blandit est malesuada id. " +
                "Mauris eros nisi, consequat ac lacus sit amet, semper congue metus. Nulla in diam est. Curabitur vitae nulla elit. " +
                "Quisque eu lacinia arcu. Morbi vel nibh elit. Donec posuere justo id tortor maximus pretium. " +
                "Aliquam malesuada a tortor eget maximus. In nec orci volutpat lorem sodales commodo nec pulvinar sapien. " +
                "Nulla in orci magna. Mauris ex massa, accumsan et semper nec, pharetra at nibh. " +
                "Quisque condimentum, purus a posuere maximus, orci felis vulputate risus, a facilisis massa risus vel velit. " +
                "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Orci varius natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. " +
                "Cras semper, sem sed vehicula suscipit, eros lorem facilisis lorem, at luctus felis nibh id enim. " +
                "Donec velit risus, luctus vel erat molestie, volutpat finibus arcu. Quisque eleifend ipsum eu sem consectetur molestie. " +
                "Proin suscipit eleifend cursus. Phasellus pharetra velit vel orci ultrices, sit amet scelerisque nibh malesuada. " +
                "Cras nisl diam, tincidunt vitae diam sit amet, tempor lacinia turpis. Curabitur iaculis orci sit amet orci luctus.";

        assertThat(StringHasher.generateHash(input)).hasSize(64);
    }

    @Test
    @DisplayName("Testing that calling String hasher and giving it specified algorithm")
    public void input_hashingUsingSpecifiedAlgorithm_correctHash() {
        String input = "th1sIsSuperStr0ngPa$$w0rd";
        //generated by https://passwordsgenerator.net/sha256-hash-generator/
        String expectedHash = "fc3fba6d04183664dc21986555188cdf305ab7176454410d5aac19dc84b8d9d6";
        assertThat(StringHasher.generateHash(input, "SHA-256")).isEqualTo(expectedHash);

        expectedHash = "39e36ba9335c0e5fc9dd8a66d0ea816490476c14c2ae9d6c50555f591b4591423404a6932b33311a21c956e00760a23340ed288c5786b68d8b0e6791b8d92a88";
        assertThat(StringHasher.generateHash(input, "SHA-512")).isEqualTo(expectedHash);

        expectedHash = "eb0c0bd7f88ac2334a6b6bc498468a0ddbdf2e29";
        assertThat(StringHasher.generateHash(input, "SHA-1")).isEqualTo(expectedHash);

        expectedHash = "d893ff511ddd72435cee4256ff31303a";
        assertThat(StringHasher.generateHash(input, "MD5")).isEqualTo(expectedHash);
    }

    @Test
    @DisplayName("Testing that calling String hasher with incorrect algorithm throws Exception")
    public void input_hashingUsingIncorrectAlgorithm_throwsException() {
        String input = "th1sIsSuperStr0ngPa$$w0rd";
        //generated by https://passwordsgenerator.net/sha256-hash-generator/
        assertThatThrownBy(() -> StringHasher.generateHash(input, "SHA-255")).isInstanceOf(IncorrectHashingAlgorithm.class);

        assertThatThrownBy(() -> StringHasher.generateHash(input, "MD-5")).isInstanceOf(IncorrectHashingAlgorithm.class);
    }
}
